/*
 * VITAL-5G monitoring platform
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package it.nextworks.nfvmano.v5g.monitoring.model;

import java.util.Objects;

import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
/**
 * BaseMetric
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2022-07-14T13:52:23.591Z[GMT]")
public class BaseMetric {
  @SerializedName("metricId")
  private String metricId = null;

  @SerializedName("verticalServiceInstanceId")
  private String verticalServiceInstanceId = null;

  /**
   * Gets or Sets testbed
   */
  @JsonAdapter(TestbedEnum.Adapter.class)
  public enum TestbedEnum {
    ATHENS("ATHENS"),
    ANTWERP("ANTWERP"),
    GALATI("GALATI"),
    DANUBE("DANUBE");

    private String value;

    TestbedEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static TestbedEnum fromValue(String input) {
      for (TestbedEnum b : TestbedEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<TestbedEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final TestbedEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public TestbedEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return TestbedEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("testbed")
  private TestbedEnum testbed = null;

  /**
   * Gets or Sets metricGraphType
   */
  @JsonAdapter(MetricGraphTypeEnum.Adapter.class)
  public enum MetricGraphTypeEnum {
    LINE("LINE"),
    BAR("BAR");

    private String value;

    MetricGraphTypeEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static MetricGraphTypeEnum fromValue(String input) {
      for (MetricGraphTypeEnum b : MetricGraphTypeEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<MetricGraphTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final MetricGraphTypeEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public MetricGraphTypeEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return MetricGraphTypeEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("metricGraphType")
  private MetricGraphTypeEnum metricGraphType = null;

  @SerializedName("unit")
  private String unit = null;

  @SerializedName("useCase")
  private String useCase = null;

  @SerializedName("topic")
  private String topic = null;


  /**
   * Gets or Sets metricCollectionType
   */
  @JsonAdapter(MetricCollectionTypeEnum.Adapter.class)
  public enum MetricCollectionTypeEnum {
    CUMULATIVE("CUMULATIVE"),
    DELTA("DELTA"),
    GAUGE("GAUGE");

    private String value;

    MetricCollectionTypeEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static MetricCollectionTypeEnum fromValue(String input) {
      for (MetricCollectionTypeEnum b : MetricCollectionTypeEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<MetricCollectionTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final MetricCollectionTypeEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public MetricCollectionTypeEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return MetricCollectionTypeEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("metricCollectionType")
  private MetricCollectionTypeEnum metricCollectionType = null;

  public BaseMetric metricId(String metricId) {
    this.metricId = metricId;
    return this;
  }

   /**
   * Get metricId
   * @return metricId
  **/
  @Schema(required = true, description = "")
  public String getMetricId() {
    return metricId;
  }

  public void setMetricId(String metricId) {
    this.metricId = metricId;
  }

  public BaseMetric verticalServiceInstanceId(String verticalServiceInstanceId) {
    this.verticalServiceInstanceId = verticalServiceInstanceId;
    return this;
  }

   /**
   * Get verticalServiceInstanceId
   * @return verticalServiceInstanceId
  **/
  @Schema(required = true, description = "")
  public String getVerticalServiceInstanceId() {
    return verticalServiceInstanceId;
  }

  public void setVerticalServiceInstanceId(String verticalServiceInstanceId) {
    this.verticalServiceInstanceId = verticalServiceInstanceId;
  }

  public BaseMetric testbed(TestbedEnum testbed) {
    this.testbed = testbed;
    return this;
  }

   /**
   * Get testbed
   * @return testbed
  **/
  @Schema(required = true, description = "")
  public TestbedEnum getTestbed() {
    return testbed;
  }

  public void setTestbed(TestbedEnum testbed) {
    this.testbed = testbed;
  }

  public BaseMetric metricGraphType(MetricGraphTypeEnum metricGraphType) {
    this.metricGraphType = metricGraphType;
    return this;
  }

   /**
   * Get metricGraphType
   * @return metricGraphType
  **/
  @Schema(description = "")
  public MetricGraphTypeEnum getMetricGraphType() {
    return metricGraphType;
  }

  public void setMetricGraphType(MetricGraphTypeEnum metricGraphType) {
    this.metricGraphType = metricGraphType;
  }

  public BaseMetric unit(String unit) {
    this.unit = unit;
    return this;
  }

   /**
   * Get unit
   * @return unit
  **/
  @Schema(required = true, description = "")
  public String getUnit() {
    return unit;
  }

  public void setUnit(String unit) {
    this.unit = unit;
  }

  public BaseMetric useCase(String useCase) {
    this.useCase = useCase;
    return this;
  }

   /**
   * Get useCase
   * @return useCase
  **/
  @Schema(required = true, description = "")
  public String getUseCase() {
    return useCase;
  }

  public void setUseCase(String useCase) {
    this.useCase = useCase;
  }

  public BaseMetric topic(String topic) {
    this.topic = topic;
    return this;
  }

   /**
   * Get topic
   * @return topic
  **/
  @Schema(description = "")
  public String getTopic() {
    return topic;
  }

  public void setTopic(String topic) {
    this.topic = topic;
  }




  public BaseMetric metricCollectionType(MetricCollectionTypeEnum metricCollectionType) {
    this.metricCollectionType = metricCollectionType;
    return this;
  }

   /**
   * Get metricCollectionType
   * @return metricCollectionType
  **/
  @Schema(required = true, description = "")
  public MetricCollectionTypeEnum getMetricCollectionType() {
    return metricCollectionType;
  }

  public void setMetricCollectionType(MetricCollectionTypeEnum metricCollectionType) {
    this.metricCollectionType = metricCollectionType;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    BaseMetric baseMetric = (BaseMetric) o;
    return Objects.equals(this.metricId, baseMetric.metricId) &&
        Objects.equals(this.verticalServiceInstanceId, baseMetric.verticalServiceInstanceId) &&
        Objects.equals(this.testbed, baseMetric.testbed) &&
        Objects.equals(this.metricGraphType, baseMetric.metricGraphType) &&
        Objects.equals(this.unit, baseMetric.unit) &&
        Objects.equals(this.useCase, baseMetric.useCase) &&
        Objects.equals(this.topic, baseMetric.topic) &&

        Objects.equals(this.metricCollectionType, baseMetric.metricCollectionType);
  }

  @Override
  public int hashCode() {
    return Objects.hash(metricId, verticalServiceInstanceId, testbed, metricGraphType, unit, useCase, topic,  metricCollectionType);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class BaseMetric {\n");
    
    sb.append("    metricId: ").append(toIndentedString(metricId)).append("\n");
    sb.append("    verticalServiceInstanceId: ").append(toIndentedString(verticalServiceInstanceId)).append("\n");
    sb.append("    testbed: ").append(toIndentedString(testbed)).append("\n");
    sb.append("    metricGraphType: ").append(toIndentedString(metricGraphType)).append("\n");
    sb.append("    unit: ").append(toIndentedString(unit)).append("\n");
    sb.append("    useCase: ").append(toIndentedString(useCase)).append("\n");
    sb.append("    topic: ").append(toIndentedString(topic)).append("\n");
    sb.append("    metricCollectionType: ").append(toIndentedString(metricCollectionType)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
